/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef COLLISIONALGO_H
#define COLLISIONALGO_H

#include <spug/RCBase.h>
#include <spug/RCPtr.h>
#include "Vector.h"

SPUG_RCPTR(CollisionAlgo);
class Collidable;

/**
 * Interface for collision algorithms.
 */
class CollisionAlgo : virtual public spug::RCBase {
   public:

      /**
       * Checks for a collision with "collidable"   Returns true if there was
       * a collision.
       * @param distance if there will be a collision, this will be set to the
       *                 distance to the collision
       */
      virtual bool checkForCollision(const Vector &position,
                                     const Vector &velocity,
                                     const Collidable &other,
                                     Float &distance
                                     ) const = 0;
};

#endif
