/*===========================================================================*\

   $Id$

   Copyright (C) 2007 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:
 
   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#ifndef POLY_H
#define POLY_H

/**
 * Abstract interface for a polygon.
 */
class Poly {
   public:

      virtual ~Poly() {}

      /**
       * Returns the number of sides of the polygon.
       */
      virtual size_t getSideCount() const = 0;

      /**
       * Returns the indexed vertex of the polygon.
       */
      virtual const Vector &getVertex(int index) const = 0;
};

inline std::ostream &operator <<(std::ostream &out, const Poly &poly) {
   size_t sides = poly.getSideCount();
   out << "Poly(";
   for (int i = 0; i < sides; ++i)
      out << poly.getVertex(i);
   out << ")";
   return out;
}

#endif
